// Copyright: Daisuke Okanohara
// Lincense: New BSD Lincense

#ifndef __TX_HPP__
#define __TX_HPP__

#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

#include "ssv.hpp"

namespace tx_tool{
  using namespace std;

  class tx{
  public:
    tx();
    ~tx();
    int build(vector<string>& wordList, const char* fileName) const;
    int read(const char* fileName);

    uint searchLongestPrefix(const char* str, const size_t len, size_t& retLen, bool matchPrefix= false) const;
    uint searchPrefixes(const char* str, const size_t len, vector<string>& ret) const;
    uint searchExpansions(const char* str, const size_t len, vector<string>& ret, const uint limit = 0) const;
    static uint NOTFOUND;

  private:
    uint getChild(const uint pos, const char c) const;
    void enumerateAll(const uint pos, const string str, vector<pair<size_t,string> >& ret) const; 
    uint strToPos(const char* str, const size_t len, vector<string>* prefixes) const;
    bool isTerminal(const uint pos) const;
    ssv loud;
    ssv terminal;
    char* edge;
  };

}

#endif // __TX_HPP__
